/*****************************************************************************
**
** program_ugnx3_set_component_attribute.cpp
**
** Description:
**     Contains Unigraphics entry points for the application.

28  2006  

 -
  
 -      

   -     -     -
     =    


         
   ,    
     

**
*****************************************************************************/

/* Include files */
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#   include <strstream>
#   include <iostream>
    using std::ostrstream;
    using std::endl;    
    using std::ends;
    using std::cerr;
#else
#   include <strstream.h>
#   include <iostream.h>
#endif


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>


#include <uf.h>
#include <uf_ui.h>
#include <uf_ui_types.h>
#include <uf_exit.h>
#include <uf_disp.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_vec.h>
#include <uf_mtx.h>
#include <uf_csys.h>
#include <uf_attr.h>



#define UF_CALL(X) (report_error( __FILE__, __LINE__, #X, (X)))

#define PRTERR(line)if(errorCode){PrintErrorMessage(errorCode,line);\
	errorCode=0;goto term;}

#define FREE_OBJ(object)\
	if(object)\
		for(i=0;i<count;i++)\
		{\
			errorCode=UF_DISP_set_highlight(object[i],0);\
			PRTERR(__LINE__);\
		}\
	UF_free(object);

static	FILE*		prterr;
static	int			errorCode;


static int report_error( char *file, int line, char *call, int irc)
{
    if (irc)
    {
        char err[133],
             msg[133];

        sprintf(msg, "*** ERROR code %d at line %d in %s:\n+++ ",
            irc, line, file);
        UF_get_fail_message(irc, err);

        UF_print_syslog(msg, FALSE);
        UF_print_syslog(err, FALSE);
        UF_print_syslog("\n", FALSE);
        UF_print_syslog(call, FALSE);
        UF_print_syslog(";\n", FALSE);

        if (!UF_UI_open_listing_window())
        {
            UF_UI_write_listing_window(msg);
            UF_UI_write_listing_window(err);
            UF_UI_write_listing_window("\n");
            UF_UI_write_listing_window(call);
            UF_UI_write_listing_window(";\n");
        }
    }

    return(irc);
}


static	void	PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"errorCode=%d		message=%s		line=%d\n",
			errorCode,message,line);
		fflush(prterr);
	}
}


int	component_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_component_type,0,0};

	ret_code=UF_UI_set_sel_mask
		(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples,mask_triples);

	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;
	else
		return UF_UI_SEL_FAILURE;
}


void	do_it(void)
{
	int
		rivet_count;
	tag_t
		rivet_array[30000];

label_select:
	//  
	{
		tag_p_t
			object;
		int
			i,response,

			//e scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY,
			//    
			//..       
			scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY,

        	count;
		char*
			message="  ";
		char*
			title=" ";
		void*
			user_data=NULL;

		errorCode=UF_UI_select_with_class_dialog
			(message,title,scope,component_init_proc,NULL,&response,&count,&object);
		PRTERR(__LINE__);

		switch(response)
		{
		
		case UF_UI_BACK:
			FREE_OBJ(object);
			goto label_select;
		
		case UF_UI_CANCEL:
			FREE_OBJ(object);
			goto term;
		
		}

		//  
		if(count<=0)
		{
			uc1601("  ",1);
			FREE_OBJ(object);
			goto label_select;
		}

		//   
		for(i=0;i<count;i++)
			rivet_array[i]=object[i];

		rivet_count=count;

		//    
		FREE_OBJ(object);

	}


	//		-	  


	//      -  
	struct	rivet_name{
		char
			name[50];//   -  
		tag_t
			tag;//  

	};

	typedef	struct	rivet_name	riv_strt;

	riv_strt
		rivet_represent[100];
	int
		represent_count;



	//     
	{
		int
			equal_flag,//       
			i,j;
		tag_t
			component;
		char
			message[300],
			instance_name[30+1],
			refset_name[30+1],
			part_name[256+1];
		double
			transform[4][4],
			csys_matrix[9],
			origin[3];
			

		component=rivet_array[0];
		represent_count=0;

		//    
		//ask component data
		errorCode=UF_ASSEM_ask_component_data
			(component,part_name,refset_name,instance_name,origin,csys_matrix,transform);
		PRTERR(__LINE__);
		strcpy(rivet_represent[represent_count].name,part_name);
		rivet_represent[represent_count].tag=component;
		represent_count++;
		
		for(i=0;i<rivet_count;i++)
		{
			component=rivet_array[i];
			
			//ask component data
			errorCode=UF_ASSEM_ask_component_data
				(component,part_name,refset_name,instance_name,origin,csys_matrix,transform);
			PRTERR(__LINE__);
			
			equal_flag=1;
			for(j=0;j<represent_count;j++)
				if(strcmp(rivet_represent[j].name,part_name)==0)
				{
					equal_flag=0;//   ,  
					break;//    j
				}

			if(equal_flag)//    
				{
					strcpy(rivet_represent[represent_count].name,part_name);
					rivet_represent[represent_count].tag=component;
					represent_count++;
				}
		}

		sprintf(message,"represent_count=%d",represent_count);
		//uc1601(message,1);

	}
	//  -       



	//   
	{
		int
			i,j,
			count_tag;
		tag_t*
			part_occs;
		tag_t
			part_tag;
		char
			message[300];
			
		rivet_count=0;
		for(i=0;i<represent_count;i++)
		{
			//ask part tag 
			//uc1601(rivet_represent[i].name,1);
			part_tag=UF_PART_ask_part_tag(rivet_represent[i].name);
			if(part_tag==NULL_TAG)
			{
				uc1601("    ",1);
				fprintf(prterr,
					"    		line=%d\n",__LINE__);
				goto term;
			}

			//   
			count_tag=UF_ASSEM_ask_occs_of_part(NULL,part_tag,&part_occs);

			//    
			for(j=0;j<count_tag;j++)
			{
				rivet_array[rivet_count]=part_occs[j];
				rivet_count++;
			}

			UF_free(part_occs);

			sprintf(message,"instance_count=%d",count_tag);
			//uc1601(message,1);

		}

	}
	// -         



	//  
	{
		char*	
			title="RIVET";
		char*
			rivet_type="work";
		UF_ATTR_value_t 
			value;
		int
			i;

		value.type = UF_ATTR_string;
		value.value.string = rivet_type;
        		
		for(i=0;i<rivet_count;i++)
		{
			errorCode=UF_ATTR_assign (rivet_array[i],title,value); 
			PRTERR(__LINE__);
		}

	
	}
	// -        










	goto term;
term:
	;

}


/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
    //   
	struct tm*
		newtime;
	time_t
		aclock,start_time,
		finish_time;
	double
		work_time;
	int
		min,sec;
	tag_t
		part;


	time(&start_time);// 

	//     D:
	if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
	{
		//uc1601("  <prterr.txt>    D:\\",1);
		goto label_clock;
	}

	//     C:/TEMP/
	if((prterr=fopen("C:\\TEMP\\prterr.txt","w"))!=NULL)
	{
		uc1601("  <prterr.txt>    C:\\TEMP\\",1);
		goto label_clock;
	}

	//    
	uc1601("    ",1);
	return;


label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	fprintf(prterr,"\n<set_component_attribute>		HAS STARTED		line=%d\n\n",__LINE__);
	fprintf(prterr,"   :	%s\n\n",asctime(newtime));

	errorCode=UF_initialize();PRTERR(__LINE__);


	//     
	part=UF_PART_ask_display_part();
	if(part==NULL_TAG)
	{
		uc1601(",    !",1);
		fprintf(prterr,"     	line=%d\n",__LINE__);
		goto term;
	}


	//todo--------------------------------------------------------------
	do_it();




	errorCode=UF_terminate();PRTERR(__LINE__);

term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"<set_component_attribute>	HAS FINISHED	line=%d\n\n",
		__LINE__);
	fprintf(prterr,"working time is		%u	min		%u sec\n",min,sec);
	fflush(prterr);
	fclose(prterr);

	if(UF_is_initialized())
		UF_terminate();

	return;
}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}
